unit ChangeNom_main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ComCtrls,
  EditBtn, FileCtrl, ShellCtrls, ExtCtrls, Buttons, StdCtrls,
  IniFiles; //Fichier .ini

const
  //Ini
  IniNom_ = 'ChangeNom.ini';

type

  { TWdMain }

  TWdMain = class(TForm)
    ComboBox1: TComboBox;
    Edit1: TEdit;
    Edit3: TEdit;
    Edit7: TEdit;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Memo1: TMemo;
    Panel1: TPanel;
    Panel2: TPanel;
    ShellListView1: TShellListView;
    ShellTreeView1: TShellTreeView;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    procedure ComboBox1Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure Panel1Click(Sender: TObject);
    procedure Panel2Click(Sender: TObject);
    procedure ShellListView1Click(Sender: TObject);
    procedure ShellTreeView1Click(Sender: TObject);
    procedure ShellTreeView1MouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: integer);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  WdMain: TWdMain;
  DirExe: string;

implementation

{$R *.lfm}

{ TWdMain }

var
  Chemin: string;
  Mx, My: integer;
  CarMini: integer;
  DebutFin: integer;
  NodeClic: TTreeNode;

//----- Ini --------------------------------------------------
procedure Ini_Lire;
var
  FIni: TiniFile;
  Fichier: string;
  DirTr: string;
begin
  with WdMain do
  begin
    DirTr := '';
    Fichier := DirExe + IniNom_;
    if FileExists(Fichier) then
      with WdMain do
      begin
        FIni := TiniFile.Create(Fichier);
        //----- Position X,Y -----
        DirTr := FIni.ReadString('Path', 'Travail', '');

        Fini.Free;
      end;
    if DirTr <> '' then
    begin
      if DirectoryExists(DirTr) then
      begin
        Chemin := DirTr;
        Edit3.Text := DirTr;
      end;
    end;
  end;
end;

procedure Ini_Sauve;
var
  FIni: TiniFile;
  s: string;
begin
  with WdMain do
  begin
    FIni := TiniFile.Create(DirExe + IniNom_);
    //----- Répertoire de travail -----
    s := Edit3.Text;
    if s = '' then
      s := DirExe;
    FIni.WriteString('Path', 'Travail', s);

    Fini.Free;
  end;
end;

procedure Renommer(Select: byte);
var
  Nom0, Nom1, Nom2: string;
  Ren, Ext: string;
  n, Nb: integer;
  Total: integer;
begin
  with WdMain do
  begin
    if Select = 1 then
      Total := 0;
    Ren := Edit1.Text;
    if Ren <> '' then
    begin
      Nb := ShellListView1.Items.Count;
      if Nb > 1 then
        Edit7.Text := ' ' + IntToStr(Nb) + ' fichiers'
      else
        Edit7.Text := ' ' + IntToStr(Nb) + ' fichier';
      if Nb > 0 then
      begin
        Memo1.Lines.Clear;

        for n := 0 to Nb - 1 do
        begin
          Nom1 := ShellListView1.Items[n].Caption;
          Nom0 := ChangeFileExt(Nom1, '');
          Ext := ExtractFileExt(Nom1);
          if Length(Nom0) > CarMini then
          begin
            Inc(Total);
            Nom2 := '';
            case DebutFin of
              1: Nom2 := Ren + Nom0 + Ext;
              2: Nom2 := Nom0 + Ren + Ext;
            end;
            //Memo1.Lines.Add(Nom2);
            Memo1.Lines.Add(Nom2);
            if Select = 2 then
            begin
              if not RenameFile(UTF8ToSys(Chemin + Nom1), UTF8ToSys(Chemin + Nom2)) then
              begin
                Memo1.Lines.Add('- REN error : ' + Nom2);
              end;
            end;
          end
          else
          begin
            Memo1.Lines.Add('    [' + Nom1 + '] ' +
              IntToStr(Length(Nom0)) + ' car.');
          end;
        end;
        case Select of
          1:
          begin
            if Total > 0 then
              SpeedButton2.Enabled := True
            else
              SpeedButton2.Enabled := False;
          end;
          2:
          begin
            //NodeClic:=ShellTreeView1.GetNodeAt(Mx,My);
            //Refresh Node
            //ShellTreeView1.Items.GetFirstNode.Selected:=True;
            ShellTreeView1.Items[0].Selected := True;
            //UpDate
            ShellTreeView1.Path := 'C:\';
            ShellTreeView1.Path := Chemin;
            SpeedButton2.Enabled := False;
          end;
        end;
      end;
    end
    else
    begin
      ShowMessage('   Entrez le texte de renommage.   ');
      SpeedButton2.Enabled := False;
    end;
  end;
  //é
end;

procedure Valide;
begin
  Renommer(2);
  WdMain.SpeedButton2.Enabled := False;
end;

procedure TWdMain.SpeedButton1Click(Sender: TObject);
begin
  Renommer(1);
end;

procedure TWdMain.SpeedButton2Click(Sender: TObject);
begin
  Valide;
end;

procedure TWdMain.SpeedButton4Click(Sender: TObject);
begin
  ShellTreeView1.SaveToFile('ListeRepertoires.txt');
  ShowMessage('   Liste des répertoires sauvée (ListeRepertoires.txt)');
end;

procedure TWdMain.SpeedButton5Click(Sender: TObject);
var
  Txt: TextFile;
  Nom: string;
  n, Nb: integer;
begin
  AssignFile(Txt, DirExe + 'ListeFichiers.txt');
 {$i-}
  Rewrite(Txt);
{$i+}
  if Ioresult = 0 then
  begin
    Nb := ShellListView1.Items.Count;
    if Nb > 0 then
    begin
   {$i-}
      Writeln(Txt, IntToStr(Nb) + ' fichiers.');
{$i+}
      for n := 0 to Nb - 1 do
      begin
        Nom := Chemin + ShellListView1.Items[n].Caption;
    {$i-}
        Writeln(Txt, Nom);
{$i+}
      end;
    end;
  {$i-}
    CloseFile(Txt);
{$i+}
    ShowMessage('   Liste des fichiers sauvée (ListeFichiers.txt)');
  end
  else
    ShowMessage('   Erreur en création du fichier Texte.   ');
end;

procedure TWdMain.SpeedButton6Click(Sender: TObject);
begin
  Memo1.Lines.SaveToFile('Memo.txt');
  ShowMessage('   Mémo sauvé (Memo.txt)');
end;

procedure TWdMain.SpeedButton7Click(Sender: TObject);
begin
  ShellTreeView1.Path := 'C:\';
  ShellTreeView1.Path := Chemin;
end;

procedure TWdMain.Panel1Click(Sender: TObject);
begin
  DebutFin := 1;
  with Panel1 do
  begin
    Color := ClLime;
    BevelInner := bvLowered;
    BevelOuter := bvRaised;
  end;
  with Panel2 do
  begin
    Color := ClSilver;
    BevelInner := bvRaised;
    BevelOuter := bvRaised;
  end;
end;

procedure TWdMain.Panel2Click(Sender: TObject);
begin
  DebutFin := 2;
  with Panel1 do
  begin
    Color := ClSilver;
    BevelInner := bvRaised;
    BevelOuter := bvRaised;
  end;
  with Panel2 do
  begin
    Color := Cllime;
    BevelInner := bvLowered;
    BevelOuter := bvRaised;
  end;
end;

procedure TWdMain.ShellListView1Click(Sender: TObject);
var
  Idx: integer;
  Nom: string;
begin
  Idx := ShellListView1.ItemIndex;
  if Idx > -1 then
  begin
    Nom := ShellListView1.Items[Idx].Caption;
    Nom := ChangeFileExt(Nom, '');
    Edit1.Text := ExtractFileName(Nom);
  end;
end;

procedure TWdMain.ShellTreeView1Click(Sender: TObject);
var
  //s :string;
  Nb: integer;
begin
  Memo1.Clear;
  SpeedButton2.Enabled := False;

  NodeClic := ShellTreeView1.GetNodeAt(Mx, My);
  Chemin := ShellTreeView1.GetPathFromNode(NodeClic);
  if Chemin[Length(Chemin)] <> '\' then
    Chemin := Chemin + '\';
  Edit3.Text := Chemin;
  Nb := ShellListView1.Items.Count;
  if Nb > 1 then
    Edit7.Text := IntToStr(Nb) + ' fichiers'
  else
    Edit7.Text := IntToStr(Nb) + ' fichier';
end;

procedure TWdMain.ShellTreeView1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: integer);
begin
  Mx := X;
  My := Y;
end;

procedure TWdMain.ComboBox1Change(Sender: TObject);
begin
  CarMini := ComboBox1.ItemIndex + 1;
  if CarMini < 1 then
    CarMini := 1;
  if CarMini > 9 then
    CarMini := 9;
  SpeedButton2.Enabled := False;
end;

procedure TWdMain.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  Ini_Sauve;
end;

procedure TWdMain.FormShow(Sender: TObject);
//var
//  Tn:TTreeNode;
begin
  DirExe := ExtractFilePath(Application.ExeName);
  if DirExe[Length(DirExe)] <> '\' then
    DirExe := DirExe + '\';

  DebutFin := 1;

  CarMini := ComboBox1.ItemIndex + 1;
  if CarMini < 1 then
    CarMini := 1;
  if CarMini > 9 then
    CarMini := 9;

  if ShellTreeView1.Items.Count >= 0 then
  begin
    //ShellTreeView1.Items.GetFirstNode.Selected:=True;
    ShellTreeView1.Items[0].Selected := True;
    Chemin := ShellTreeView1.Items[0].Text;
    if Chemin[Length(Chemin)] <> '\' then
      Chemin := Chemin + '\';
    Edit3.Text := Chemin;
  end;

  Ini_Lire;

  ShellTreeView1.Path := Chemin;
  ActiveControl := Edit1;
end;

end.
